import RelativeArticle from '.';
import { Component, Request } from '@pjblog/http';
import { ArticleDBO, TagDBO, BlogArticleEntity } from '@pjblog/core';
import type { EntityManager } from 'typeorm';
interface IArticle {
    title: string;
    id: number;
    code: string;
    ctime: string | Date;
}
export type IResponse = IArticle[];
export declare class RelativeArticlesController extends Component<IResponse> {
    readonly manager: EntityManager;
    readonly service: ArticleDBO;
    readonly container: RelativeArticle;
    readonly tag: TagDBO;
    constructor(req: Request);
    getArticle(): Promise<BlogArticleEntity>;
    getTags(): Promise<number[]>;
    getRelatives(): Promise<void>;
}
export {};
