"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RelativeArticlesController = void 0;
const _1 = __importDefault(require("."));
const utils_1 = require("./utils");
const http_1 = require("@pjblog/http");
const exception_1 = require("@typeservice/exception");
const core_1 = require("@pjblog/core");
const manager_1 = require("@pjblog/manager");
const typeorm_1 = require("@pjblog/typeorm");
let RelativeArticlesController = class RelativeArticlesController extends http_1.Component {
    constructor(req) {
        super(req, []);
        this.manager = (0, manager_1.getNode)(typeorm_1.TypeORM).value.manager;
        this.container = (0, manager_1.getNode)(_1.default);
        this.service = new core_1.ArticleDBO(this.manager);
        this.tag = new core_1.TagDBO(this.manager);
    }
    async getArticle() {
        const id = (0, core_1.numberic)(0)(this.req.params.id);
        if (!id)
            throw new exception_1.HttpNotFoundException('找不到文章');
        const article = await this.service.getOne(id);
        if (!article)
            throw new exception_1.HttpNotFoundException('找不到文章');
        return article;
    }
    async getTags() {
        const article = this.getCache('getArticle');
        const tags = await this.tag.get(article.id);
        return tags.map(tag => tag.id);
    }
    async getRelatives() {
        const article = this.getCache('getArticle');
        const tags = this.getCache('getTags');
        if (!tags.length)
            return;
        this.res = await this.manager.getRepository(core_1.BlogTagRelativeEntity).createQueryBuilder('rel')
            .leftJoin(core_1.BlogArticleEntity, 'art', 'art.id=rel.aid')
            .select('art.article_title', 'title')
            .addSelect('art.id', 'id')
            .addSelect('art.article_code', 'code')
            .addSelect('art.gmt_create', 'ctime')
            .distinct()
            .where('rel.tid IN (:...tids)', { tids: tags })
            .andWhere('rel.aid<>:aid', { aid: article.id })
            .limit(this.container.storage.get('articles'))
            .getRawMany();
    }
};
__decorate([
    (0, http_1.Water)(1),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], RelativeArticlesController.prototype, "getArticle", null);
__decorate([
    (0, http_1.Water)(2),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], RelativeArticlesController.prototype, "getTags", null);
__decorate([
    (0, http_1.Water)(3),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], RelativeArticlesController.prototype, "getRelatives", null);
RelativeArticlesController = __decorate([
    (0, utils_1.Controller)('GET', '/:id(\\d+)'),
    __metadata("design:paramtypes", [http_1.Request])
], RelativeArticlesController);
exports.RelativeArticlesController = RelativeArticlesController;
